import math
import threading
import time

from fischertechnik.controller.Motor import Motor
from lib.controller import *


impulses_per_degree_pan = None
impulses_per_degree_tilt = None


def Init_Pan():
    global impulses_per_degree_pan, impulses_per_degree_tilt
    TXT_M_M1_encodermotor.set_speed(int(512), Motor.CCW)
    TXT_M_M1_encodermotor.start_sync()
    while True:
        if (TXT_M_I1_mini_switch.is_closed()):
            break
        time.sleep(0.010)
    TXT_M_M1_encodermotor.set_speed(int(512), Motor.CW)
    TXT_M_M1_encodermotor.set_distance(int(round(87 * impulses_per_degree_pan)))
    while True:
        if (not TXT_M_M1_encodermotor.is_running()):
            break
        time.sleep(0.010)


def Init_Tilt():
    global impulses_per_degree_pan, impulses_per_degree_tilt
    TXT_M_M2_encodermotor.set_speed(int(512), Motor.CCW)
    TXT_M_M2_encodermotor.start_sync()
    while True:
        if (TXT_M_I2_mini_switch.is_closed()):
            break
        time.sleep(0.010)
    TXT_M_M2_encodermotor.set_speed(int(512), Motor.CW)
    TXT_M_M2_encodermotor.set_distance(int(round(78 * impulses_per_degree_tilt)))
    while True:
        if (not TXT_M_M2_encodermotor.is_running()):
            break
        time.sleep(0.010)


impulses_per_degree_pan = 10.295
impulses_per_degree_tilt = 5.325
threading.Thread(target=Init_Pan, daemon=True).start()
threading.Thread(target=Init_Tilt, daemon=True).start()
while True:
    pass
